// dba.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "dba.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define AD(lpDsp, drv, ErrStr) \
drv.AttachDispatch(lpDsp); \
if(	drv.m_lpDispatch == NULL ) {AfxMessageBox(ErrStr, MB_OK | MB_ICONSTOP | MB_TASKMODAL);	return FALSE;}

#define FD(drv) \
if(drv.m_lpDispatch) \
{LPDISPATCH lpDsp = drv.m_lpDispatch; drv.DetachDispatch(); lpDsp->Release();}

void FromCollection( COleDispatchDriver& Collection, COleDispatchDriver& item, int Index /* zero based */)
{
	VARIANT result;
	
	static BYTE parms[] =
		VTS_VARIANT;
	
	COleVariant index((short)Index,VT_I2);

	Collection.InvokeHelper(0x0, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, parms,
		&index);

	item.AttachDispatch(result.pdispVal);
}

/////////////////////////////////////////////////////////////////////////////
// CDaoViewApp commands

void DisplayDaoException(CDaoException* e)
{
	CString strMsg;
	if (e->m_pErrorInfo!=NULL)
	{
		strMsg.Format(
			_T("%s   (%d)\n\n")
			_T("Would you like to see help?"),
			(LPCTSTR)e->m_pErrorInfo->m_strDescription,
			e->m_pErrorInfo->m_lErrorCode);

		if (AfxMessageBox(strMsg, MB_YESNO) == IDYES)
		{
			WinHelp(GetDesktopWindow(),
					e->m_pErrorInfo->m_strHelpFile,
					HELP_CONTEXT,
					e->m_pErrorInfo->m_lHelpContext);
		}
	}
	else
	{
		strMsg.Format(
			_T("ERROR:CDaoException\n\n")
			_T("SCODE_CODE      =%d\n")
			_T("SCODE_FACILITY  =%d\n")
			_T("SCODE_SEVERITY  =%d\n")
			_T("ResultFromScode =%d\n"),
			SCODE_CODE      (e->m_scode),
			SCODE_FACILITY  (e->m_scode),
			SCODE_SEVERITY  (e->m_scode),
			ResultFromScode (e->m_scode));
		AfxMessageBox(strMsg);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CDba

IMPLEMENT_DYNCREATE(CDba, CCmdTarget)

CDba::CDba()
{
	INIT_DBA = FALSE;
}

CDba::~CDba()
{
}


BEGIN_MESSAGE_MAP(CDba, CCmdTarget)
	//{{AFX_MSG_MAP(CDba)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDba message handlers

BOOL CDba::InitDBA(LPDISPATCH lpApDispatch)
{

    if(INIT_DBA) return FALSE;



    CWaitCursor wc;

	AD(lpApDispatch,m_apps,_T("No AP Attach"));

	AD(m_apps.GetDoCmd(),m_DoCmd,_T("No Cmd Attach"));

	LPDISPATCH lpDb = m_apps.CodeDb();

	Database db;

	db.AttachDispatch(lpDb);

	CString name = db.GetName();

	db.DetachDispatch();

	lpDb->Release();

	LPDISPATCH lpEng = m_apps.GetDBEngine();

	_DBEngine eng;

	eng.AttachDispatch(lpEng);

	CString ver = eng.GetVersion();

	float v;
#ifdef _UNICODE
	swscanf((LPCTSTR)ver,_T("%f"),&v);
#else
	sscanf((LPCTSTR)ver,"%f",&v);
#endif

	eng.DetachDispatch();

	lpEng->Release();


	if (!m_dbDAO.IsOpen())
	{
		// First assume stdreg32.mdb file is in current directory
		try
		{
			if( v >= 3.55 ) AfxGetModuleState()->m_dwVersion = 0x0601; //for dynamic libs	
			m_dbDAO.Open(name);
		}
		catch (CDaoException* e)
		{
			// Assume failure is becauase we couldn't find the file
			DisplayDaoException(e);
			e->Delete();
			m_DoCmd.DetachDispatch();
			m_apps.DetachDispatch();
			return FALSE;
		}
	}


    INIT_DBA = TRUE;

		return TRUE;
}


void CDba::TermDBA()
{
	if(!INIT_DBA) return;

	m_dbDAO.Close();	
	
	m_DoCmd.DetachDispatch();
	m_db.DetachDispatch();
	m_apps.DetachDispatch();


	INIT_DBA = FALSE;
}


void CDba::PreQuery(CString& Name)
{
CDaoDatabase* pDB = &m_dbDAO;
CDaoQueryDefInfo querydefinfo;
short count = pDB->GetQueryDefCount();


	for( short i = 0; i < count; i++ )
	{
	pDB->GetQueryDefInfo( i, querydefinfo );

       if(!querydefinfo.m_strName.Compare((LPCTSTR)Name))
	   { 
		   pDB->DeleteQueryDef(Name);
	       break;
	   }
	}
}

BOOL CDba::FormPresent(CString& Name)
{

    BOOL ret = FALSE;
	Forms frms;
	AD(m_apps.GetForms(),frms,_T("No Forms Attach"));

	 long  count = frms.GetCount();

	for( long i = 0; i < count; i++ )
	{
		CString name;
		_Form frm;

		FromCollection(frms,frm,i);

		name = frm.GetName();

       if(!name.Compare((LPCTSTR)Name))
	   { 
		   ret = TRUE;
           FD(frm);
	       break;
	   }

		FD(frm);
	
	}
	FD(frms);
	return ret;
}

void CDba::OpenForm(CString& FormName, CString& OpenArgs, int mode, HWND hwnd)
{

	long form_mode;

	switch( mode)
	{
	case MODAL:   // 1
		form_mode = 3L;
		break;
	case NOMODAL:  // 0
	default :
		form_mode = 0L;
		break;
	}


	try
    {
	m_DoCmd.OpenForm(
		COleVariant(FormName),
	0L,  //acNormal
		COleVariant(_T("")),
		COleVariant(_T("")),
	-1L,
	form_mode, // 0-acWindowNormal     3-acDialog
		COleVariant(OpenArgs));
   }
    catch( COleDispatchException* e )
    {
         AfxMessageBox( 
                e->m_strDescription, 
                MB_ICONEXCLAMATION | MB_OK | MB_ICONSTOP | MB_TASKMODAL );
        e->Delete();
		return;
    }
 
	if( mode == MODAL && hwnd )
	{
		::BringWindowToTop(hwnd);
	}
}


CDba Dba;


CDba& GetDBA()
{
        return Dba;
}

