// GeoPnts.cpp : implementation file
//

#include "stdafx.h"
#include "stdio.h"
#include "Dba.h"
#include "rscoll.h"
#include "GeoPnt.h"
#include "resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern HINSTANCE hInstExt;


#ifdef _UNICODE

HRESULT __fastcall A2W(LPCSTR pszA, LPOLESTR* ppszW) { 
    ULONG cCharacters;
    DWORD dwError;

    // If input is null then just return the same.
    if (NULL == pszA)
    {
        *ppszW = NULL;
        return NOERROR;
    }

    // Determine number of wide characters to be allocated for the
    // Unicode string.
    cCharacters =  strlen(pszA)+1;

    // Use of the OLE allocator is required if the resultant Unicode
    // string will be passed to another COM component and if that
    // component will free it. Otherwise you can use your own allocator.
    *ppszW = (LPOLESTR) CoTaskMemAlloc(cCharacters*2);
    if (NULL == *ppszW)
        return E_OUTOFMEMORY;

    // Covert to Unicode.
    if (0 == MultiByteToWideChar(CP_ACP, 0, pszA, cCharacters,
                  *ppszW, cCharacters))
    {
        dwError = GetLastError();
        CoTaskMemFree(*ppszW);
        *ppszW = NULL;
        return HRESULT_FROM_WIN32(dwError);
    }

    return NOERROR;
} 


HRESULT __fastcall W2A(LPCOLESTR pszW, LPSTR* ppszA) { 
    ULONG cbAnsi, cCharacters;
    DWORD dwError;

    // If input is null then just return the same.
    if (pszW == NULL)
    {
        *ppszA = NULL;
        return NOERROR;
    }

    cCharacters = wcslen(pszW)+1;
    // Determine number of bytes to be allocated for ANSI string. An
    // ANSI string can have at most 2 bytes per character (for Double
    // Byte Character Strings.)
    cbAnsi = cCharacters*2;

    // Use of the OLE allocator is not required because the resultant
    // ANSI  string will never be passed to another COM component. You
    // can use your own allocator.
    *ppszA = (LPSTR) CoTaskMemAlloc(cbAnsi);
    if (NULL == *ppszA)
        return E_OUTOFMEMORY;

    // Convert to ANSI.
    if (0 == WideCharToMultiByte(CP_ACP, 0, pszW, cCharacters, *ppszA,
                  cbAnsi, NULL, NULL))
    {
        dwError = GetLastError();
        CoTaskMemFree(*ppszA);
        *ppszA = NULL;
        return HRESULT_FROM_WIN32(dwError);
    }

    return NOERROR;
} 
#endif // _UNICODE

/*
//----gp
     long Index;
     long PointID;
	 CString Name
	 long X;
     long Y;

*/


/////////////////////////////////////////////////////////////////////////////
// CGeoPoint

IMPLEMENT_DYNCREATE(CGeoPoint, CCmdTarget)


CGeoPoint::CGeoPoint()
{
	 Index = -1L;
	 PointID = -1L;
	 Name = CString("");
	 X = 0;
	 Y = 0;
	Updated = TRUE;
}

CGeoPoint::~CGeoPoint()
{
}

void CGeoPoint::operator=(CGeoPoint& gp)
{
	Index = gp.Index;
	 PointID = gp.PointID;
	 Name = gp.Name;
	 X = gp.X;
	 Y = gp.Y;

	 Updated = gp.Updated;
}

BEGIN_MESSAGE_MAP(CGeoPoint, CCmdTarget)
	//{{AFX_MSG_MAP(CGeoPoint)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGeoPoint message handlers


/////////////////////////////////////////////////////////////////////////////
// CGeoPoints

IMPLEMENT_DYNCREATE(CGeoPoints, CCmdTarget)


CGeoPoints::CGeoPoints()
{
    pOwner = NULL;
	IsReady = FALSE;
	Tracker.m_rect = CRect(-1,-1,-1,-1);
	ActiveIndex = -1L;
	gpArr = NULL;


}

CGeoPoints::~CGeoPoints()
{
}


BEGIN_MESSAGE_MAP(CGeoPoints, CCmdTarget)
	//{{AFX_MSG_MAP(CGeoPoints)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGeoPoints message handlers

/////////////////////////////////////////////////////////////////////////////
// CGeoPoints message handlers
BOOL CGeoPoints::OpenRsGP(long activeID, long onlyID)
{
  char buf[256];

	if(IsReady) return FALSE;

  if( onlyID != -1L )
  {
	wsprintfA(buf,"(PointID = %d);",onlyID);
   RsGP.m_strFilter = CString(buf);
  }

   RsGP.OpenM(pOwner->GetSafeHwnd());

   long count = RsGP.GetCount();
   if( count > 0L )
   {
     if( gpArr ) delete [] gpArr;
	 gpArr = new CGeoPoint[count];

	 RsGP.MoveFirst();
	 for( long i = 0L; i<count; i++)
	 {
				 gpArr[i].Index = i;
				 gpArr[i].PointID = RsGP.m_PointID;
				 gpArr[i].Name = RsGP.m_Name;
				 gpArr[i].X = RsGP.m_X;
				 gpArr[i].Y = RsGP.m_Y;

					if( activeID == gpArr[i].PointID ) ActiveIndex = i;
					 RsGP.MoveNext();
		}

   }

      IsReady = TRUE;

  	CRsEx rs;
	rs.Open();
	rs.AddNew();
	rs.m_HWND = (long)pOwner->m_hWnd;
	rs.m_PointID = (ActiveIndex == -1L) ? -1L : gpArr[ActiveIndex].PointID;
	  if( ActiveIndex != -1L )
	  {
		rs.m_X = gpArr[ActiveIndex].X;
		rs.m_Y = gpArr[ActiveIndex].Y;
	  }
	rs.Update();
	rs.Close();


   if( activeID != -1L )
   {
	   wsprintfA(buf,"Place = %ld",gpArr[ActiveIndex].PointID);
        RsGP.Find(AFX_DAO_FIRST, CString(buf));

   CPoint p;
	    p.x = (long)gpArr[ActiveIndex].X;
		p.y = (long)gpArr[ActiveIndex].Y;

		Mouse = p;

    p.Offset(-pOwner->GetScrollPosition());

	CClientDC dc(pOwner);
   pOwner->OnPrepareDC(&dc);

				m_rectTracker = CRect(CPoint(p-CPoint(16,16)),CSize(32,32));
				  dc.DPtoLP(m_rectTracker);
				  pOwner->Invalidate();



	  rs.m_strFilter = GetExFilter();
	  rs.Open();
	  rs.Edit();
	  rs.m_PointID = (ActiveIndex == -1L) ? -1L : gpArr[ActiveIndex].PointID;
	  if( ActiveIndex != -1L )
	  {
		rs.m_X = gpArr[ActiveIndex].X;
		rs.m_Y = gpArr[ActiveIndex].Y;
	  }
	  rs.Update();
	  rs.Close();

   }


	 return TRUE;

}

void CGeoPoints::CloseRsGP()
{
	 if(!IsReady) return;

	 if( gpArr )
	 {
		 delete [] gpArr;
		 gpArr = NULL;
	 }

	CRsEx rs;
	

	rs.m_strFilter = GetExFilter();
	rs.Open();
    rs.Delete();
	rs.Close();

	if( RsGP.IsOpen()) RsGP.CloseM();

	ActiveIndex = -1L;

	IsReady = FALSE;
}

void CGeoPoints::Init(CScrollView* pSV)
{

    pOwner = pSV;
	
	marker = (HICON)::LoadIcon(hInstExt, MAKEINTRESOURCE(IDI_MARKER));
 
	OpenRsGP();


}


void CGeoPoints::Refresh()
{
  ActiveIndex = -1L;
  Tracker.m_rect = CRect(-1,-1,-1,-1);
  pOwner->Invalidate();
}


void CGeoPoints::Draw(CDC * pDC)
{
		if( !IsReady || !RsGP.GetCount() ) return;


	 BOOL ret;
		long row;

	 
     long count = RsGP.GetCount();

	 pDC->SetTextAlign( TA_CENTER );

     for(row=0;row<count;row++)
	 {
 
		 CGeoPoint& gp = gpArr[row];

	ret = pDC->DrawIcon(gp.X-16,gp.Y-16,marker);
	ret = pDC->TextOut( gp.X, gp.Y + 20, gp.Name );

	 }

     
	if(ActiveIndex != -1L)
	 {
	CRect tmprect = m_rectTracker;
     pDC->LPtoDP(tmprect); // update logical coordinates
	 Tracker.m_rect = tmprect;
     Tracker.Draw(pDC);
	 }

}

CString CGeoPoints::GetExFilter()
{
	   char filter[256];
	   wsprintfA(filter,"HWND = %ld",(long)pOwner->m_hWnd);
	   return CString(filter);
}

BOOL CGeoPoints::Find(CPoint& p)
{
		if( !IsReady || !RsGP.GetCount() ) return FALSE;
	
 	
	long OldActiveIndex = ActiveIndex;

	 
		long sel,row;
		sel = -1L;


     for(row=0L;row<RsGP.GetCount();row++)
	 {
		 CGeoPoint& gp = gpArr[row];

	    CPoint pt((long)gp.X,(long)gp.Y);
		CRect r( pt.x-16, pt.y-16, pt.x+16, pt.y+16 );

		if( r.PtInRect(p) )
		{
				sel=row;
				break;
		}
	 }

	 //------------------- restore moved point to original

		   if((ActiveIndex != sel) && (ActiveIndex != -1L) && (!gpArr[ActiveIndex].Updated))
		   {
			   gpArr[ActiveIndex].X = RsGP.m_X;
			   gpArr[ActiveIndex].Y = RsGP.m_Y;
			   gpArr[ActiveIndex].Updated = TRUE;
		   }


           ActiveIndex = sel;

		   if(ActiveIndex != -1L ) Mouse = CPoint((long)gpArr[ActiveIndex].X,(long)gpArr[ActiveIndex].Y);


		  if( (ActiveIndex != -1L) && (OldActiveIndex != ActiveIndex))
		  {
		   char buff[64];
		   wsprintfA(buff,"PointID = %ld",gpArr[ActiveIndex].PointID);
           RsGP.Find(AFX_DAO_FIRST, CString(buff));
		  }

		  return (OldActiveIndex != ActiveIndex);
}

void CGeoPoints::OnButton(CPoint& p, int nFlag)
{

              Mouse = p;

			if( !IsReady || !RsGP.GetCount() )
			{
				return;
			}
	
	BOOL sel = Find(p);

    CPoint cliPoint = Mouse;
    cliPoint.Offset(-pOwner->GetScrollPosition());


	  CRsEx rsEx;
	  rsEx.m_strFilter = GetExFilter();
	  rsEx.Open();
	  rsEx.Edit();
	  rsEx.m_PointID = (ActiveIndex == -1L) ? -1L : gpArr[ActiveIndex].PointID;
	  if( ActiveIndex != -1L )
	  {
			rsEx.m_X = gpArr[ActiveIndex].X;
			rsEx.m_Y = gpArr[ActiveIndex].Y;
	  }
	  else
	  {
		  rsEx.m_X = Mouse.x;
		  rsEx.m_Y = Mouse.y;
	  }
	  rsEx.Update();
	  rsEx.Close();

    if( ActiveIndex == -1L )
	{

	    if( sel )
		{
			Tracker.m_rect = CRect(-1,-1,-1,-1);
			  pOwner->Invalidate();
		}
			  return;
	}

	CClientDC dc(pOwner);
      pOwner->OnPrepareDC(&dc);

	switch(nFlag)
	{
	 case MK_LBUTTON:

				if( sel )
				{
				m_rectTracker = CRect(CPoint(cliPoint-CPoint(16,16)),CSize(32,32));
				  dc.DPtoLP(m_rectTracker);
				  pOwner->Invalidate();
				}
    if (Tracker.Track(pOwner, cliPoint, FALSE, NULL))
	{
      m_rectTracker = Tracker.m_rect;
      dc.DPtoLP(m_rectTracker); // update logical coordinates
    
	  Mouse = CPoint(m_rectTracker.left+16,m_rectTracker.top+16);

	     gpArr[ActiveIndex].X = Mouse.x;
		 gpArr[ActiveIndex].Y = Mouse.y;
		 gpArr[ActiveIndex].Updated = FALSE;

     pOwner->Invalidate();
	}

		break;
	case MK_RBUTTON:

 				if( sel )
				{
				m_rectTracker = CRect(CPoint(cliPoint-CPoint(16,16)),CSize(32,32));
				dc.DPtoLP(m_rectTracker); // update logical coordinates
				pOwner->Invalidate();
				}
		break;
	default:
		break;
	}
}

BOOL CGeoPoints::SelMoved()
{
if(ActiveIndex == -1L  || !RsGP.GetCount()) return FALSE;

 		 return !gpArr[ActiveIndex].Updated;

}
	
void CGeoPoints::OnDestroy() 
{
	// TODO: Add your command handler code here

    CloseRsGP();

}
// operations
#define Insert    1 
#define Edit      2 
#define Update    3 
#define Delete    4 
// objects
#define Point     0 
#define Data      1 

void CGeoPoints::OpenForm( int proc, long object)
{
	CRsFrm rsFrm;
	rsFrm.Open();

	char buff[128];

    wsprintfA(buff,"object = %ld",object);
    rsFrm.Find(AFX_DAO_FIRST, CString(buff));


 	CString formname;
	
	switch(proc)
	{
	case Insert:
		formname = rsFrm.m_Insert;
			break;
	case Edit:
		formname = rsFrm.m_Edit;
			break;
	case Update:
		formname = rsFrm.m_Update;
			break;
	case Delete:
		formname = rsFrm.m_Delete;
			break;
	default:
		formname = CString(_T(""));
			break;
	}
	rsFrm.Close();

	CString filter = GetExFilter();


	if( !formname.IsEmpty() ) GetDBA().OpenForm(formname,filter,1,::GetParent(pOwner->m_hWnd));


}



void CGeoPoints::OnDataInsert() 
{
	// TODO: Add your command handler code here
	long object = Data;
	OpenForm( Insert, object );
	
}

void CGeoPoints::OnDataEdit() 
{
	// TODO: Add your command handler code here

	long object = Data;
	OpenForm( Edit, object);
	
}

void CGeoPoints::OnDataUpdate() 
{
	// TODO: Add your command handler code here

	long object = Data;
	OpenForm( Update, object);
	
}

void CGeoPoints::OnDataDelete() 
{
	// TODO: Add your command handler code here

	long object = Data;
	OpenForm( Delete, object);
	
}

void CGeoPoints::OnPointInsert() 
{
	// TODO: Add your command handler code here
	long object = Point;
	OpenForm( Insert, object);
}

void CGeoPoints::OnPointEdit() 
{
	// TODO: Add your command handler code here
	long object = Point;
	OpenForm( Edit, object);
	
}

void CGeoPoints::OnPointUpdate() 
{
	// TODO: Add your command handler code here

	long object = Point;
	OpenForm( Update, object);
	
}

void CGeoPoints::OnPointDelete() 
{
	// TODO: Add your command handler code here
	long object = Point;
	OpenForm( Delete, object);
	
}