// rscoll.cpp : implementation file
//

#include "stdafx.h"
#include "dba.h"
#include "rscoll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CString UniName(HWND hwnd)
{

 char temp[30];
 if( hwnd ) wsprintfA(temp,"Query%lX",(unsigned long)hwnd);
 else strcpy((LPSTR)temp,"QueryTemp");

 return CString(temp);
}

/////////////////////////////////////////////////////////////////////////////
// CW99Recordset

IMPLEMENT_DYNAMIC(CW99Recordset, CDaoRecordset)

CW99Recordset::CW99Recordset()
	: CDaoRecordset(&GetDBA().m_dbDAO)
{
	//{{AFX_FIELD_INIT(CW99Recordset)
	//}}AFX_FIELD_INIT
	m_nDefaultType = dbOpenDynaset;
	count = 0L;
}

void CW99Recordset::DoFieldExchange(CDaoFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CW99Recordset)
	pFX->SetFieldType(CDaoFieldExchange::outputColumn);
	//}}AFX_FIELD_MAP
}

CString CW99Recordset::GetDefaultDBName()
{
	return GetDBA().m_dbDAO.GetName();
}

void CW99Recordset::Open(int nOpenType, LPCTSTR lpszSql, int nOptions, BOOL calcCount) 
{
	// TODO: Add your specialized code here and/or call the base class
	
 	try
	{
		CDaoRecordset::Open(nOpenType, lpszSql, nOptions ? nOptions : dbSeeChanges);
	}
	catch(CDaoException* e)
	{
		AfxMessageBox(e->
			m_pErrorInfo->m_strDescription);
		e->Delete();
		return;
	}
			if(calcCount) CalcCount();

}
BOOL CW99Recordset::OpenM(HWND hwndView,const BOOL NoRecIsErr) 
{
	// TODO: Add your specialized code here and/or call the base class

		  	if( IsOpen() ) return FALSE;

   	RsName = UniName(hwndView);
	GetDBA().PreQuery(RsName);

 	try
	{
	Open();
	}
	catch(CDaoException* e)
	{
		AfxMessageBox(e->
			m_pErrorInfo->m_strDescription);
		e->Delete();
		return FALSE;
	}

	CalcCount();

	if( NoRecIsErr && !count ) return FALSE;


	m_pQueryDef->Close();
	m_pQueryDef->Create(RsName,m_strSQL);
	m_pQueryDef->Append();

	return TRUE;

}

void CW99Recordset::CloseM() 
{
	// TODO: Add your specialized code here and/or call the base class

		  	if( !IsOpen() ) return;

    	m_pDatabase->DeleteQueryDef(RsName);
		 m_pQueryDef->Close();
		 m_pQueryDef->Open();

		 CDaoRecordset::Close();
		 count = 0L;
}

void CW99Recordset::CalcCount() 
{
	// TODO: Add your specialized code here and/or call the base class

		  	if( !IsOpen() ) return;

			long current_pos = GetAbsolutePosition();
		if( current_pos == -1L )
		{
			count = 0L;
			return;
		}

		MoveLast();
		count = GetRecordCount();

		SetAbsolutePosition(current_pos);
}
void CW99Recordset::Requery() 
{
	// TODO: Add your specialized code here and/or call the base class

		 CDaoRecordset::Requery();
		 CalcCount();
}

/////////////////////////////////////////////////////////////////////////////
// CW99Recordset diagnostics

#ifdef _DEBUG
void CW99Recordset::AssertValid() const
{
	CDaoRecordset::AssertValid();
}

void CW99Recordset::Dump(CDumpContext& dc) const
{
	CDaoRecordset::Dump(dc);
}
#endif //_DEBUG

long CW99Recordset::GetCount()
{

		if(!IsOpen()) return 0L;
        
		return count;
}


void CW99Recordset::DeleteAll()
{
	BOOL shouldClose = FALSE;

		if(!IsOpen())
		{
		Open();
		if(IsOpen()) shouldClose = TRUE;
		else return;
		}

		while (!IsEOF())
		{
	try
	{
		Delete();
	}
	catch(CDaoException* e)
	{
		AfxMessageBox(e->
			m_pErrorInfo->m_strDescription);
		e->Delete();
	}
			MoveNext();
		}

       if( shouldClose ) Close();
}


/////////////////////////////////////////////////////////////////////////////
// CRsLnPrm

IMPLEMENT_DYNAMIC(CRsLnPrm, CW99Recordset)

CRsLnPrm::CRsLnPrm()
	: CW99Recordset()
{
	//{{AFX_FIELD_INIT(CRsLnPrm)
	m_LineID = 0;
	m_PStyle = 0;
	m_Width = 0;
	m_R = 0;
	m_G = 0;
	m_B = 0;
	m_Closed = TRUE;
	m_Hatched = FALSE;
	m_HStyle = 0;
	m_nFields = 9;
	//}}AFX_FIELD_INIT
	m_nDefaultType = dbOpenDynaset;
}

CString CRsLnPrm::GetDefaultSQL()
{
	return _T("[t_lnprm]");
}

void CRsLnPrm::DoFieldExchange(CDaoFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CRsLnPrm)
	pFX->SetFieldType(CDaoFieldExchange::outputColumn);
	DFX_Long(pFX, _T("[LineID]"), m_LineID);
	DFX_Byte(pFX, _T("[PStyle]"), m_PStyle);
	DFX_Short(pFX, _T("[Width]"), m_Width);
	DFX_Byte(pFX, _T("[R]"), m_R);
	DFX_Byte(pFX, _T("[G]"), m_G);
	DFX_Byte(pFX, _T("[B]"), m_B);
	DFX_Bool(pFX, _T("[Closed]"), m_Closed);
	DFX_Bool(pFX, _T("[Hatched]"), m_Hatched);
	DFX_Byte(pFX, _T("[HStyle]"), m_HStyle);
	//}}AFX_FIELD_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CRsLnPrm diagnostics

#ifdef _DEBUG
void CRsLnPrm::AssertValid() const
{
	CW99Recordset::AssertValid();
}

void CRsLnPrm::Dump(CDumpContext& dc) const
{
	CW99Recordset::Dump(dc);
}
#endif //_DEBUG
/////////////////////////////////////////////////////////////////////////////
// CRsLine

IMPLEMENT_DYNAMIC(CRsLine, CW99Recordset)

CRsLine::CRsLine()
	: CW99Recordset()
{
	//{{AFX_FIELD_INIT(CRsLine)
	m_NodeID = 0;
	m_Line = 0;
	m_X = 0.0;
	m_Y = 0.0;
	m_nFields = 4;
	//}}AFX_FIELD_INIT
	m_strSort = "NodeID";
	m_nDefaultType = dbOpenDynaset;
}


CString CRsLine::GetDefaultSQL()
{
	return _T("[t_line]");
}

void CRsLine::DoFieldExchange(CDaoFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CRsLine)
	pFX->SetFieldType(CDaoFieldExchange::outputColumn);
	DFX_Long(pFX, _T("[NodeID]"), m_NodeID);
	DFX_Long(pFX, _T("[Line]"), m_Line);
	DFX_Double(pFX, _T("[X]"), m_X);
	DFX_Double(pFX, _T("[Y]"), m_Y);
	//}}AFX_FIELD_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CRsLine diagnostics

#ifdef _DEBUG
void CRsLine::AssertValid() const
{
	CW99Recordset::AssertValid();
}

void CRsLine::Dump(CDumpContext& dc) const
{
	CW99Recordset::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CRsGP

IMPLEMENT_DYNAMIC(CRsGP, CW99Recordset)

CRsGP::CRsGP()
	: CW99Recordset()
{
	//{{AFX_FIELD_INIT(CRsGP)
	m_PointID = 0;
	m_Name = _T("");
	m_X = 0;
	m_Y = 0;
	m_nFields = 4;
	//}}AFX_FIELD_INIT
	m_nDefaultType = dbOpenDynaset;
}

CString CRsGP::GetDefaultSQL()
{
	return _T("[t_point]");
}

void CRsGP::DoFieldExchange(CDaoFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CRsGP)
	pFX->SetFieldType(CDaoFieldExchange::outputColumn);
	DFX_Long(pFX, _T("[PointID]"), m_PointID);
	DFX_Text(pFX, _T("[Name]"), m_Name);
	DFX_Long(pFX, _T("[X]"), m_X);
	DFX_Long(pFX, _T("[Y]"), m_Y);
	//}}AFX_FIELD_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CRsGP diagnostics

#ifdef _DEBUG
void CRsGP::AssertValid() const
{
	CW99Recordset::AssertValid();
}

void CRsGP::Dump(CDumpContext& dc) const
{
	CW99Recordset::Dump(dc);
}
#endif //_DEBUG
/////////////////////////////////////////////////////////////////////////////
// CRsEx

IMPLEMENT_DYNAMIC(CRsEx, CW99Recordset)

CRsEx::CRsEx()
	: CW99Recordset()
{
	//{{AFX_FIELD_INIT(CRsEx)
	m_HWND = 0;
	m_PointID = 0;
	m_X = 0;
	m_Y = 0;
	m_nFields = 4;
	//}}AFX_FIELD_INIT
	m_nDefaultType = dbOpenDynaset;
}


CString CRsEx::GetDefaultSQL()
{
	return _T("[t_exchange]");
}

void CRsEx::DoFieldExchange(CDaoFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CRsEx)
	pFX->SetFieldType(CDaoFieldExchange::outputColumn);
	DFX_Long(pFX, _T("[HWND]"), m_HWND);
	DFX_Long(pFX, _T("[PointID]"), m_PointID);
	DFX_Long(pFX, _T("[X]"), m_X);
	DFX_Long(pFX, _T("[Y]"), m_Y);
	//}}AFX_FIELD_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CRsEx diagnostics

#ifdef _DEBUG
void CRsEx::AssertValid() const
{
	CW99Recordset::AssertValid();
}

void CRsEx::Dump(CDumpContext& dc) const
{
	CW99Recordset::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CRsFrm

IMPLEMENT_DYNAMIC(CRsFrm, CW99Recordset)

CRsFrm::CRsFrm()
	: CW99Recordset()
{
	//{{AFX_FIELD_INIT(CRsFrm)
	m_Object = 0;
	m_Insert = _T("");
	m_Edit = _T("");
	m_Update = _T("");
	m_Delete = _T("");
	m_nFields = 5;
	//}}AFX_FIELD_INIT
	m_nDefaultType = dbOpenDynaset;
}

CString CRsFrm::GetDefaultSQL()
{
	return _T("[t_form]");
}

void CRsFrm::DoFieldExchange(CDaoFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CRsFrmD)
	pFX->SetFieldType(CDaoFieldExchange::outputColumn);
	DFX_Long(pFX, _T("[Object]"), m_Object);
	DFX_Text(pFX, _T("[Insert]"), m_Insert);
	DFX_Text(pFX, _T("[Edit]"), m_Edit);
	DFX_Text(pFX, _T("[Update]"), m_Update);
	DFX_Text(pFX, _T("[Delete]"), m_Delete);
	//}}AFX_FIELD_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CRsFrm diagnostics

#ifdef _DEBUG
void CRsFrm::AssertValid() const
{
	CW99Recordset::AssertValid();
}

void CRsFrm::Dump(CDumpContext& dc) const
{
	CW99Recordset::Dump(dc);
}
#endif //_DEBUG

